package com.gxzc.zen.umps.config

import org.springframework.http.HttpMethod
import org.springframework.stereotype.Component
import org.springframework.web.filter.OncePerRequestFilter
import javax.servlet.FilterChain
import javax.servlet.http.HttpServletRequest
import javax.servlet.http.HttpServletResponse

/**
 *
 * @author NorthLan
 * @date 2018/3/1
 * @url https://noahlan.com
 */
@Component
class CORSFilter : OncePerRequestFilter() {
    override fun doFilterInternal(request: HttpServletRequest, response: HttpServletResponse, filterChain: FilterChain) {
        response.let {
            it.addHeader("Access-Control-Allow-Origin", request.getHeader("Origin"))//request.getHeader("Origin")
            it.addHeader("Access-Control-Allow-Credentials", "true")
            it.addHeader("Access-Control-Allow-Methods", "GET, HEAD, POST, PUT, DELETE, TRACE, OPTIONS, PATCH")
            it.addHeader("Access-Control-Max-Age", "3600")
            it.addHeader("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept")
            val method = HttpMethod.valueOf(request.method)
            if (method == HttpMethod.POST || method == HttpMethod.PUT) {
                it.addHeader("Access-Control-Expose-Headers", "Location")
            }
        }

        filterChain.doFilter(request, response)
    }
}