package com.gxzc.zen.web.sys.controller

import com.baomidou.kisso.annotation.Action
import com.baomidou.kisso.annotation.Login
import com.gxzc.zen.common.util.HttpUtil
import lombok.extern.slf4j.Slf4j
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.ControllerAdvice
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.servlet.mvc.method.annotation.AbstractJsonpResponseBodyAdvice
import javax.servlet.http.Cookie

/**
 *
 * @author NorthLan
 * @date 2018/4/20
 * @url https://noahlan.com
 */
@ControllerAdvice
@RequestMapping("/jsonp")
@Slf4j
class JsonpTest : AbstractJsonpResponseBodyAdvice("callback") {

    @GetMapping("getCookie")
    @Login(action = Action.Skip)
    fun getCookie(): ResponseEntity<*> {

        return ResponseEntity.ok(HttpUtil.getRequest().cookies)
    }
}